// Copyright (c) 2016, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

/// @assertion Functions include function declarations, methods, getters,
/// setters, constructors and function literals.
/// All functions have a signature and a body.
/// functionSignature:
///   metadata returnType? identifier formalParameterList
/// ;
/// returnType: void | type
/// ;
/// functionBody:
///   async? '=>' expression ';' | (async | async* | sync*)? block
/// ;
/// block:
///   '{' statements '}'
/// ;
///
/// @description Checks that it is a compile error if there is async function
/// with no return type specified among Future.wait() values
/// @author sgrekhov@unipro.ru

import 'dart:async';

f() async => 1;

test() async {
  await Future.wait([f()]);
//                  ^
// [analyzer] unspecified
// [cfe] unspecified
}
main() {
  test();
}
