// Copyright (c) 2011, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

/// @assertion A multi-line comment begins with the token '/*' and ends with the
/// token '*/'. Everything between '/*' and '*/' must be ignored by the Dart
/// compiler unless the comment is a documentation comment. Comments may nest.
/// MULTI LINE COMMENT  :
///   '/''*' (MULTI LINE COMMENT | ~ '*''/')* '*''/'
/// ;
/// @description Checks that it is a compile-time error when there is an unpaired
/// multi-line comment start token inside another multi-line comment.
/// @author rodionov


/*
//^
// [cfe] unspecified
/* Comment */
/*/* Nested comment **/ */
/*/* */ /* Unpaired token **/
*/

main() {
}
// [error line 27, column 0]
// [analyzer] unspecified