// Copyright (c) 2022, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

/// @assertion A record type declares all of the members defined on [Object]. It
/// also exposes getters for each named field where the name of the getter is
/// the field's name and the getter's type is the field's type. For each
/// positional field, it exposes a getter whose name is $ followed by the number
/// of preceding positional fields and whose type is the type of the field.
///
/// @description Check that '$' can be used as a member name
/// @author sgrekhov22@gmail.com

import "../../Utils/expect.dart";

main() {
  ({String $}) r1 = ($: "x");
  Expect.equals("x", r1.$);

  (int $,) r2 = (1,);
  Expect.equals(1, r2.$1);
}
