// Copyright (c) 2020, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

/// @assertion We say that a type T is nullable if Null <: T and not T <: Object.
/// This is equivalent to the syntactic criterion that T is any of:
///  Null
///  S? for some S
///  S* for some S where S is nullable
///  FutureOr<S> for some S where S is nullable
///  dynamic
///  void
///
/// @description Check that null can be assigned to nullable type. Test
/// FutureOr<S> for some S where S is nullable
/// @author sgrekhov@unipro.ru

// Requirements=nnbd-weak
import "dart:async";
import "legacy_lib.dart";

main() {
  FutureOr<A?> fo1 = null;
  FutureOr<C<A>?> fo2 = null;
  FutureOr<C<A?>?> fo3 = null;
}
