// Copyright (c) 2017, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

/// @assertion List<int> convert(
///  String string, [
///  int start = 0,
///  int end
///  ])
/// Converts string to its UTF-8 code units (a list of unsigned 8-bit integers).
/// ...
/// @description Checks that this method converts string to its UTF-8 code units
/// @author sgrekhov@unipro.ru

import "dart:convert";
import "../../../Utils/expect.dart";

main() {
  Utf8Encoder encoder = new Utf8Encoder();
  for (int i = 0; i < 128; i++) {
    String s = new String.fromCharCode(i);
    Expect.listEquals([i], encoder.convert(s));
  }
  Expect.listEquals([], encoder.convert(""));
  Expect.listEquals([208, 154, 208, 184, 209, 128, 208, 184, 208, 187, 208, 187,
    208, 184, 209, 134, 208, 176, 32], encoder.convert("Кириллица "));
}
