// Copyright (c) 2017, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

/// @assertion int type
///  final
/// The type of event. See FileSystemEvent for a list of events.
/// @description Checks that this property returns type of event. Test File
/// @author sgrekhov@unipro.ru

import "dart:io";
import "../../../Utils/expect.dart";
import "../file_utils.dart";

main() async {
  await inSandbox(_main);
}

void _main(Directory sandbox) async {
  File file = getTempFileSync(parent: sandbox);
  asyncStart();

  await testFileSystemEvent<FileSystemDeleteEvent>(sandbox,
      createEvent: () async {
        file.deleteSync();
      }, test: (FileSystemEvent? event) {
        Expect.equals(FileSystemEvent.delete, event?.type);
      });
  asyncEnd();
}
