// Copyright (c) 2017, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

/// @assertion List<E> toList({bool growable: true})
/// Creates a List containing the elements of this Iterable.
/// @description Checks that the returned list is correct.
/// @author ngl@unipro.ru


import "dart:typed_data";
import "../../../Utils/expect.dart";

Int32x4 i32x4(n) => new Int32x4(n, n, n, n);

equal(o1, o2) => o1.x == o2.x && o1.y == o2.y && o1.z == o2.z && o1.w == o2.w;


check(List<Int32x4> list, bool grow) {
  var l = new Int32x4List.fromList(list);
  var res = l.toList(growable: grow);
  Expect.equals(l.length, res.length);
  for (int i = 0; i < res.length; ++i) {
    Expect.isTrue(equal(l[i], res[i]));
  }
}

main() {
  check([], false);
  check([i32x4(0)], true);
  check([i32x4(0), i32x4(1), i32x4(2), i32x4(6), i32x4(4), i32x4(5)], false);
  check([
    i32x4(0), i32x4(1), i32x4(2), i32x4(6), i32x4(4), i32x4(5), i32x4(6),
    i32x4(0), i32x4(1), i32x4(2), i32x4(6), i32x4(4), i32x4(5), i32x4(6),
    i32x4(0), i32x4(1), i32x4(2), i32x4(6), i32x4(4), i32x4(5), i32x4(6),
    i32x4(0), i32x4(1), i32x4(2), i32x4(6), i32x4(4), i32x4(5), i32x4(6),
    i32x4(0), i32x4(1), i32x4(2), i32x4(6), i32x4(4), i32x4(5), i32x4(6)
  ], true);
}
