// Copyright (c) 2013, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

/// @assertion E last
/// Returns the last element.
/// @description Checks that [last]can be set.
/// @author msyabro
/// @author sgrekhov@unipro.ru
/// @issue dart-lang/co19#130

import "dart:typed_data";
import "../../../Utils/expect.dart";

void check(List<int> array) {
  dynamic l = new Uint64List.fromList(array);
  l.last = 3;
  Expect.equals(3, l.last);
}
void checkClear(length) {
  dynamic l = new Uint64List(length);
  l.last = 3;
  Expect.equals(3, l.last);
}

main() {
  check([1]);
  check([1, 2, 3, 4, 5]);
  check([
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
  ]);

  checkClear(1);
  checkClear(100);
}
