// Copyright (c) 2018, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

/// @assertion We say that a type T0 is a subtype of a type T1 (written T0 <: T1)
/// when:
/// Type Variable Reflexivity 1: T0 is a type variable X0 or a promoted type
/// variables X0 & S0 and T1 is X0
/// @description Check that if type T0 a promoted type variables X0 & S0 and T1
/// is X0 then T0 is a subtype of T1.
/// @author sgrekhov@unipro.ru
///
/// @description Check that if type T0 is a subtype of a type T1, then instance
/// of T0 can be used as a return value of type T1
/// @author sgrekhov@unipro.ru
///
/// This test is generated from test_types/type_variable_reflexivity_1_A01.dart and
/// test_cases/return_value_x01.dart. Don't modify it!
/// If you need to change this test, then change one of the files above and then
/// run generator/generator.dart to regenerate the tests.

class X0 {
  const X0();
}
class S0 extends X0 {
}

X0 t0Instance = new S0();

X0 returnValueFunc() => t0Instance;

class ReturnValueTest {
  static X0 staticTestMethod() => t0Instance;

  X0 testMethod() => t0Instance;

  X0 get testGetter => t0Instance;
}

main() {
  X0 t0Instance = new S0();
  if (t0Instance is S0) {
    X0 returnValueLocalFunc() => t0Instance;

    returnValueFunc();
    returnValueLocalFunc();

    ReturnValueTest.staticTestMethod();

    new ReturnValueTest().testMethod();
    new ReturnValueTest().testGetter;
  }
}
