// Copyright (c) 2018, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

/// @description Check that if type T0 is a subtype of a type T1, then instance
/// of T0 can be assigned to the to local variable of type T1
/// @author sgrekhov@unipro.ru

class LocalVariableTest {

  LocalVariableTest() {
    @T1 t1 = t0Instance;
    t1 = t0Instance;
  }

  static staticTest() {
    @T1 t1 = t0Instance;
    t1 = t0Instance;
  }

  test() {
    @T1 t1 = t0Instance;
    t1 = t0Instance;
  }
}

main() {
  foo() {
    @T1 t1 = t0Instance;
    t1 = t0Instance;
  }

  @T1 t1 = t0Instance;
  t1 = t0Instance;
  foo();
  LocalVariableTest x = new LocalVariableTest();
  x.test();
  LocalVariableTest.staticTest();
}
