// Copyright (c) 2020, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

/// @assertion
/// NORM(C<T0, ..., Tn>) = C<R0, ..., Rn> where Ri is NORM(Ti)
///
/// @description Checks that NORM(C<T0, ..., Tn>) = C<R0, ..., Rn> where Ri is
/// NORM(Ti). Test FutureOr<T> == Future<T> where T <: Future<T>
/// @author sgrekhov@unipro.ru

// Requirements=nnbd-strong

import 'dart:async';

class A<X> {}
class B<X> implements A<X> {}
class C<X> {}

class C0 extends B<C<FutureOr<Null>>> implements A<C<Future<Null>?>> {}

main() {
  new C0();
}
